/////////////////////////////////////////////////////////////////////////
// Game Programming All In One, Third Edition
// Chapter 3 - DoCircles Program
/////////////////////////////////////////////////////////////////////////

#include <allegro.h>

void docircle(BITMAP *bmp, int x, int y, int color)
{
    putpixel(bmp, x, y, color);
    putpixel(bmp, x+1, y+1, color);
    rest(1); //replaced sleep()
}

int main(void)
{
    int x,y,radius;
    int red,green,blue,color;
    int ret;
    
    //initialize Allegro
    allegro_init(); 
    
    //initialize the keyboard
    install_keyboard(); 
    install_timer();

    //initialize video mode to 640x480
    ret = set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0);
    if (ret != 0) {
        allegro_message(allegro_error);
        return 1;
    }

    //display screen resolution
    textprintf_ex(screen, font, 0, 0, 15, -1,
        "DoCircles Program - %dx%d - Press ESC to quit", 
        SCREEN_W, SCREEN_H);

    //wait for keypress
    while(!key[KEY_ESC])
    {
        //set a random location
        x = 40 + rand() % (SCREEN_W-80);
        y = 40 + rand() % (SCREEN_H-80);
        radius = rand() % 40;
        
        //set a random color
        red = rand() % 255;
        green = rand() % 255;
        blue = rand() % 255;
        color = makecol(red,green,blue);
        
        //draw the circle
        do_circle(screen, x, y, radius, color, *docircle);
    }

    //end program
    allegro_exit();
    return 0;
}
END_OF_MAIN()
